with Text_IO; use Text_IO;
package body GrammatikGenerator is

   package ZeichenIO is new Enumeration_IO (Zeichen); use ZeichenIO;
 
   Regeln : Regelmenge;
   
   function istTerminal (z : Zeichen) return Boolean is
   begin
      return Zeichen'pos(z) >= AnzahlNichtterminale;
   end istTerminal;
   
--   procedure neueAlternativeHinzu(links : Nichtterminal; rechts : Zeichenarray) is
--      alt : Alternativen; -- wird fuer Modifikation benoetigt
--      zei : Zeichenfolge := null;
--   begin
--      for i in reverse rechts'range loop
--         zei := new ZeichenfolgeRec'(rechts(i),zei);
--      end loop;
--      Regeln(links) := new AlternativenRec'(zei,Regeln(links));
--   end neueAlternativeHinzu;
   
   procedure neueAlternativeHinzu(links : Nichtterminal; rechts : Zeichenarray) is
      alt : Alternativen;
      zei : Zeichenfolge := null;
   begin
      for i in reverse rechts'range loop
         zei := new ZeichenfolgeRec'(rechts(i),zei);
      end loop;
      if Regeln(links) = null then
         Regeln(links) := new AlternativenRec'(zei,Regeln(links));
      else
         alt := Regeln(links);
         while alt.andere /= null loop
            alt := alt.andere;
         end loop;
         alt.andere := new AlternativenRec'(zei,null);
      end if;
   end neueAlternativeHinzu;
   
   procedure druckeGrammatik is
      alt : Alternativen;
      zei : Zeichenfolge;
   begin
      put_line("Startsymbol:");
      put_line("   "&Zeichen'image(Startsymbol));
      new_line;
      put_line("Nichtterminale:");
      for z in Nichtterminal loop
         put_line("   "&Zeichen'image(z));
      end loop;
      new_line;
      put_line("Terminale:");
      for z in Terminal loop
         put_line("   "&Zeichen'image(z));
      end loop;
      new_line;
      put_line("Regeln:");
      for z in Nichtterminal loop
         put_line("   "&Zeichen'image(z)&" ->");
         alt := Regeln(z);
         while alt /= null loop
            put("       ");
            zei := alt.erste;
            while zei /= null loop
               put(Zeichen'image(zei.erstes)&" ");
               zei := zei.weitere;
            end loop;
            alt := alt.andere;
            if alt /= null then
               put("|");
            else
               put(".");
            end if;
            new_line;
         end loop;
      end loop;
   end druckeGrammatik;

   function istGrammatikEinfach return Boolean is
      alt1,alt2 : Alternativen;
      anzEps : Integer;
   begin
      for n in Nichtterminal loop
         alt1 := Regeln(n);
         anzEps := 0;
         while alt1 /= null loop
            if alt1.erste = null then
               anzEps := anzEps+1;
            elsif not istTerminal(alt1.erste.erstes) then
               return false;
            else
               alt2 := Regeln(n);
               while alt2 /= alt1 loop
                  if alt2.erste.erstes = alt1.erste.erstes then
                     return false;
                  end if;
                  alt2 := alt2.andere;
               end loop;
            end if;
            alt1 := alt1.andere;
         end loop;
         if anzEps > 1 then
            return false;
         end if;
      end loop;
      return true;
   end istGrammatikEinfach;
   
   function hatEpsilonRegel (n : Nichtterminal) return Boolean is
      alt : Alternativen := Regeln(n);
   begin
      while alt /= null loop
         if alt.erste = null then
            return true;
         end if;
         alt := alt.andere;
      end loop;
      return false;
   end hatEpsilonRegel;
   
   Analysefehler : Exception;
   
   function wortImSprachschatz (w : Wort) return Boolean is
   
      pos : Integer := 1; -- Position des naechsten Zeichens in w
      
      form : Zeichenfolge := new ZeichenfolgeRec'(Startsymbol,null);
      -- Satzform enhaelt zu Beginn nur das Startsymbol
      
      alt : Alternativen;
   
      function findeRegel (n : Nichtterminal; t : Terminal) return Alternativen is
      begin
         alt := Regeln(n);
         while alt /= null loop
            if alt.erste /= null and then alt.erste.erstes = t then
               return alt;
            end if;
            alt := alt.andere;
         end loop;
         alt := Regeln(n);
         while alt /= null loop
            if alt.erste = null then
               return alt;
            end if;
            alt := alt.andere;
         end loop;
         return null;
      end findeRegel;
   
      function setzeVoran (a,b : Zeichenfolge) return Zeichenfolge is
      begin
         if b = null then
            return a;
         else
            return new ZeichenfolgeRec'(b.erstes,setzeVoran(a,b.weitere));
         end if;
      end setzeVoran;
   
      procedure wendeAn (a : Alternativen) is
      begin
         if a = null then
            raise Analysefehler;
         else
            form := setzeVoran(form.weitere,alt.erste);
         end if;
      end wendeAn;

      procedure druckeKonfiguration is
         hf : Zeichenfolge := form;
      begin
         put("( ");
         for i in pos .. w'length loop
            put(w(i)); 
            put(" ");
         end loop;
         put(", ");
         while hf /= null loop
            put(hf.erstes); 
            put(" ");
            hf := hf.weitere;
         end loop;
         put_line(" )");
      end druckeKonfiguration;

   begin
   
      new_line;
      druckeKonfiguration;
      
      while pos <= w'length and form /= null loop
         if istTerminal(form.erstes) then
            if form.erstes /= w(pos) then
               raise Analysefehler;
            else
               pos := pos+1;
               form := form.weitere;
            end if;
         else
            alt := findeRegel(form.erstes,w(pos));
            wendeAn(alt);
         end if;
         put("=> ");
         druckeKonfiguration;
      end loop;
      
      -- druckeKonfiguration;
      
      if pos <= w'length then
         raise Analysefehler;
      end if;
      
      while form /= null loop
         if istTerminal(form.erstes) then
            raise Analysefehler;
         end if;
         if hatEpsilonRegel(form.erstes) then
            form := form.weitere;
            put("=> ");    
            druckeKonfiguration;
         else
            raise Analysefehler;
         end if;
      end loop;
      
      new_line;
      return true;
      
   Exception
   
      when Analysefehler => new_line;
                            put_line("Analyse mit Fehler abgebrochen");
                            new_line;
                            return false;
      
   end wortImSprachschatz;
      
begin

   for i in Nichtterminal loop
      Regeln(i) := null;
   end loop;   

end GrammatikGenerator;