-- generisches Package zum bearbeiten von Adjazenzmatrizen
-- Package Spezification

-- Festlegung eines generischen Typs Z
generic
   type Z is (<>);
   
package Matrix is

-- Aufbau einer Matrix vom Typ Z mit Zeilen und Spalten, 
-- deren Lnge der Anzahl der Elemente in Z entsprechen
   type Z_Matrix is array (Z, Z) of Boolean;

-- Festlegung der Funktionen des Packages
 

   --Die Funktion bildet aus zwei Matrizen das Matrizenprodukt 
      function Produkt (M1,M2 : Z_Matrix) return Z_Matrix;
      
   -- Die Funktion bildet die Summe aus zwei Matrizen
      function Summe (M1,M2 : Z_Matrix) return Z_Matrix;
      
   -- Die Funktion transponiert die Matrix 
      function Transponiere (M1: Z_Matrix) return Z_Matrix;
      
   -- Die Funktion berechnet die Transitive Huelle einer Matrix
      function TransHuelle(M1 : Z_Matrix) return Z_Matrix;
      
   -- Berechnung reflexiv-transitive Huelle einer Matrix
      function ReflexTransHuelle(M1: Z_Matrix) return Z_Matrix;
      
   -- Diese Prozedur gibt die bergebene Matrix auf dem Bildschirm aus
      procedure Drucke (M1: Z_Matrix;Bezeichner:String) ;
      
   -- Die Funktion macht aus zwei Matrizen eine Matrix 
   -- (nur transitive Paare)
   -- Bsp.: (a,b) in Z1, (b,c) in Z2, => (a,c) in der Rueckgabe
      function Transition (Z1,Z2 : Z_Matrix) return Z_Matrix;
      

end Matrix;