package body Relationenpaket is

   Regeln : Regelmenge;  


   -- Die Prozedur Epszaehler gibt alle Nicht-Terminale aus, 
   --  die durch die eingegeben Regeln der Grammatik 
   --  zu Epsilon werden koennen.
   --  Das Von-Hand-Ausfuehren der Beispielgrammatik:
   --   S -> CC | AE
   --   A -> BD | SC
   --   B -> aC | CSA
   --   C -> Epsilon
   --   D -> d | DS
   --   E -> bEb
   --  ergibt die Epsilon-Symbole C, S, A, B (in dieser Reihenfolge).
   --  C ist schon ein Epsilon-Symbol, S wird durch CC zum 
   --  Epsilon-Symbol, usw.
   --  Die Ausfuehrung der Funktion "Epszaehler" gibt wie 
   --  erwartet die Liste (S, A, B, C) aus. Die
   --  Reihenfolge ergibt sich aus der Indexposition des 
   --  jeweiligen Nicht-Terminals in der Zeichenliste.
   --
   --  Die erste Schleife sucht mit Hilfe der Funktion 
   --  hatEpsilonregel alle Nicht-Terminale, die direkt zu 
   --  Epsilon werden.
   --  Es werden zwei Ergebnislisten, Erglist und 
   --  Zwischenlist, definiert, die die Veraenderungen in der 
   --  Ergebnisliste festhalten. Die Schleife wird verlassen, wenn
   --  diese durch den Funktionsdurchlauf nicht veraendert wird.
   --  In Erglist sind die Index-Positionen der gesuchten 
   --  Nicht-Terminale mit "True" belegt.
   --  In Reg wird die Regelmenge durch die Funktion kopiereRegeln 
   --  kopiert, damit die Original-Regeln erhalten bleiben.
   --  Der Pointer "altpoint" zeigt waehrend des Funktionsdurchlaufes
   --  immer auf die aktuell ueberpruefte Alternative (rechte Seite).
   --  Die zwei Pointer "zeichpoint" und "merker" bekommen die 
   --  Zeichenkette der Alternative zugewiesen, damit zeichenweise 
   --  ueberprueft werden kann,
   --  ob dieses Zeichen zu einem Epsilon reduziert 
   --  werden kann. Ist dies moeglich, wechseln beide Zeiger auf
   --  das naechste Zeichen, ist dies nicht moeglich bleibt "merker"
   --  auf diesem stehen und nur "Zeichpoint" wechselt auf das
   --  naechste Zeichen, ist dies nicht vorhanden, zeigen 
   --  "zeichpoint" und "merker" auf "null" und somit ist ein weiteres
   --  Epsilon-Symbol gefunden.
   --  Ein Nicht-Terminal kann also nur als Epsilon-Symbol
   --  erkannt werden, wenn beide Pointer auf "null" zeigen.
   --  Am Ende der Funktion wird fuer jedes Nicht-Terminal geprueft, 
   --  ob es sich als Epsilon-Symbol herausgestellt hat.
   --  Dies wird erkannt, wenn das Nicht-Terminal als Alternative 
   --  nur noch "null" besitzt.
   --  Im E/A-Teil werden die Nicht-Terminale gedruckt, auf deren 
   --  Indexposition die Ergebnisliste "True" enthaelt.
   ----------------------------------------------------------------








   function Epszaehler return Listz is 
      Erglist,  
      Zwischenlist : Listz        := (others => False);  
      Reg          : Regelmenge;  
      Alt,  
      Altpoint     : Alternativen;  
      Zeichpoint,  
      Merker       : Zeichenfolge;  

      function Kopiere2 (
            F : Zeichenfolge ) 
        return Zeichenfolge is 
      begin
         if F = null then
            return null;
         else
            return new Zeichenfolgerec'(F.Erstes,Kopiere2(F.Weitere));
         end if;
      end Kopiere2;

      function Kopiere (
            G : Alternativen ) 
        return Alternativen is 
      begin
         if G = null then
            return null;
         else
            return new Alternativenrec'(Kopiere2(G.Erste),
               Kopiere(G.Andere));
         end if;
      end Kopiere;

      function Kopiereregeln (
            L : Regelmenge ) 
        return Regelmenge is 
         Neu : Regelmenge;  
      begin
         for I in L'range loop
            Neu(I) := Kopiere(L(I));
         end loop;
         return Neu;
      end Kopiereregeln;


   begin
      Regeln := Getregeln;
      Reg := Kopiereregeln(Regeln);

      for I in Nichtterminal'range loop
         if Hatepsilonregel(I) then
            Erglist(I) := True;
         end if;
      end loop;


      while Zwischenlist /= Erglist loop
         for I in Nichtterminal'range loop
            Altpoint := Reg(I);
            if not Erglist(I) then
               while Altpoint /= null loop
                  Zeichpoint := Altpoint.Erste;
                  Merker := Zeichpoint;
                  while Zeichpoint /= null loop
                     for J in Erglist'range loop
                        if Erglist(J) then
                           Altpoint := Reg(I);
                           while Altpoint /= null loop
                              Zeichpoint := Altpoint.Erste;
                              Merker := Zeichpoint;
                              while Zeichpoint /= null loop
                                 if Zeichpoint.Erstes = J then
                                    if Merker /= Zeichpoint then
                                       Zeichpoint :=
                                          Zeichpoint.Weitere;
                                       if Zeichpoint /= null then
                                          Merker.Weitere :=
                                             Zeichpoint.Weitere;
                                       else
                                          Merker.Weitere := null;
                                       end if;
                                       Altpoint.Erste.Weitere :=
                                          Merker.Weitere;
                                    else
                                       Zeichpoint := Zeichpoint.Weitere;
                                       Altpoint.Erste := Zeichpoint;
                                       Merker := Zeichpoint;
                                    end if;
                                    if Altpoint.Erste = null then
                                       Erglist(I):= True;
                                    end if;
                                 else
                                    Merker := Zeichpoint;
                                    Zeichpoint := Zeichpoint.Weitere;
                                 end if;
                              end loop;
                              Altpoint := Altpoint.Andere;
                           end loop;
                        end if;
                     end loop;
                  end loop;
               end loop;
            end if;
         end loop;

         for I in Nichtterminal'range loop
            Alt := Reg(I);
            while Alt /= null loop
               if Alt.Erste = null then
                  Erglist(I):= True;
               end if;
               Alt := Alt.Andere;
            end loop;
         end loop;
         Zwischenlist := Erglist;
      end loop;
      return Erglist;
   end Epszaehler;

   -----------------------
   --     E/A-TEIL      --
   -----------------------

   procedure Druckeeps (
         Erglist : Listz ) is 
   begin
      New_Line(2);
      Put("{ ");
      for I in Erglist'range loop
         if Erglist(I) then
            Put(Nichtterminal'Image(I) & " ");
         end if;
      end loop;
      Put_Line("} sind Epsilon-Symbole.");
   end Druckeeps;

   ----------------------------------------------------------------------
   -- Die Funktion Anfang berechnet die moeglichen Wortanfaenge.
   --  Dabei stuetzt sie sich auf die Funktion Epszaehler ab 
   --  (gibt Nicht-Terminale, die in Epsilon enden koennen, zurueck)
   --  und gibt einen Pointer auf eine Liste zurueck
   --  Die Hauptarbeit erledigt hier die funktion pruefe. Sie wurde 
   --  hier nicht Als Interne Funktion Realisiert, weil sowohl Anfang
   --  als auch Ende darauf Zugreifen Muessen. Anfang uebergibt pruefe
   --  Eine Liste Von Zeichen. Das erste Zeichen wird sofort in die
   --  Ergebnisliste aufgenommen. Danach nimmt pruefe solange die
   --  Nachfolger auf, solange sie nicht auf ein Terminales trifft und
   --  die Zeichen in der Epsilon Menge enthalten sind. Andernfalls
   --  bricht pruefe ab.     

   function Pruefe (Zeif : Zeichenfolge; Tp : Tupelpoint;
   I : Nichtterminal ) return Tupelpoint is 
      Zeiger : Tupelpoint   := Tp;  
      E      : Listz;  
      Zf     : Zeichenfolge := Zeif;  
   begin
      E := Epszaehler;
      if Zf /= null then
         Zeiger := new Tupel'(I,Zf.Erstes,Zeiger);
      end if;

      while Zf /= null and then not Istterminal(Zf.Erstes)
            and then E(Zf.Erstes) loop
         if Zf.Weitere /= null then
            Zeiger := new Tupel'(I,Zf.Weitere.Erstes,Zeiger);
         end if;
         Zf := Zf.Weitere;
      end loop;
      return Zeiger;
   end Pruefe;

   function Anfang return Tupelpoint is 
      Zeiger : Tupelpoint   := null;  
      Af     : Alternativen;  
   begin
      for I in Regeln'range loop
         Af := Regeln(I);
         while Af /= null loop
            Zeiger := Pruefe(Af.Erste,Zeiger,I);
            Af := Af.Andere;
         end loop;
      end loop;

      for I in Terminal'range loop
         Zeiger := new Tupel'(I,I,Zeiger);
      end loop;
      return Zeiger;
   end Anfang;


   -- Die Funktion Ende berechnet die moeglichen Wotanenden.
   --  Sie agiert analog zu Funktion Anfang, nur dass sie die Liste
   --  von Zeichen vorher umdreht.

   function Ende return Tupelpoint is 
      Zeiger    : Tupelpoint   := null;  
      Af        : Alternativen;  
      Umgedreht : Zeichenfolge;  
      procedure Rev (
            Zeif : Zeichenfolge ) is 
         Zf : Zeichenfolge := Zeif;  
      begin
         while Zf /= null loop
            Umgedreht := new Zeichenfolgerec'(Zf.Erstes,Umgedreht);
            Zf := Zf.Weitere;
         end loop;
      end Rev;


   begin

      for I in Regeln'range loop
         Af := Regeln(I);
         while Af /= null loop
            Rev(Af.Erste);
            Zeiger := Pruefe(Umgedreht,Zeiger,I);
            Umgedreht := null;
            Af := Af.Andere;
         end loop;
      end loop;

      for I in Terminal'range loop
         Zeiger := new Tupel'(I,I,Zeiger);
      end loop;
      return Zeiger;

   end Ende;

   ----------------------------------------------------------------------
   -- Die Funktion Neben berechnet alle benachbarten Zeichen.
   --  Dabei stuetzt sie sich auf die Funktion Epszaehler ab
   --  und gibt einen Pointer auf eine Liste zurueck.
   --  Hierzu werden in der ersten Schleife alle Regeln durchlaufen.
   --  Nur wenn an der bestimmten Position I eine Regel vorhanden 
   --  ist, wird der Pointer AF auf diese Regel gesetzt.
   --  Sollte nun der Wert "Erste" dieses Pointers existieren,
   --  wird der Pointer ZF auf diesen Wert gesetzt. In der
   --  folgenden Schleife werden die Zeichenfolgen nun durchlaufen.
   --  In der Schleife wird nun geprueft, ob ein Folgeelement existiert
   --  Ist dies nicht der Fall, wird die Schleife verlassen.
   --  Als naechstes werden die Zeichen, die bei der Definition der 
   --  Grammatik nebeneinander stehen, in die Ergebnisliste uebernommen
   --  bzw. eine neue Ergebnisliste angelegt.
   --  Nun wird ein neuer Pointer initialisiert, der auf den Folgewert 
   --  der Zeichenfolge zeigt.
   --  In der folgenden Schleife werden die Zeichenfolgen durchlaufen
   --  und es wird geprueft, ob ein Folgeelement existiert.
   --  Ist dies nicht der Fall, wird die Schleife verlassen.
   --  Anschlieend wird geprueft ob, das Zeichen "zwischen" 
   --  den Zeigern ein Epsilonsymbol ist.
   --  Wenn dies der Fall ist, werden die Werte der beiden Zeiger in 
   --  die Ergebnisliste uebernommen.
   --  Als letztes wird in dieser Schleife der Pointer ZF2 auf das 
   --  naechste Element gesetzt, solange das aktuelle Zeichen zwischen
   --  dem Ersten und Zweiten Zeiger ein Epsilonsymbol war.
   --  Letztendlich wird die Ergebnisliste zurueckgegeben. 

   function Neben return Tupelpoint is 
      Zeiger     : Tupelpoint   := null;  
      Zf,  
      Zf2        : Zeichenfolge;  
      Af         : Alternativen;  
      Ergebnisse : Listz;  
   begin
      Ergebnisse := Epszaehler;
      for I in Regeln'range loop
         Af := Regeln(I);
         while Af /= null loop
            Zf := Af.Erste;
            while (Zf /= null) loop
               if(Zf.Weitere = null) then
                  exit;
               end if;
               if Zeiger = null then
                  Zeiger :=
                     new Tupel'(Zf.Erstes, Zf.Weitere.Erstes, null);
               else
                  Zeiger :=
                     new Tupel'(Zf.Erstes, Zf.Weitere.Erstes, Zeiger);
               end if;
               Zf2 := Zf.Weitere;
               while ((Zf2 /= null)) loop
                  if(Zf2.Weitere = null) then
                     exit;
                  end if;
                  if Ergebnisse(Zf2.Erstes)
                        then
                     Zeiger := new Tupel'(Zf.Erstes, Zf2.Weitere.Erstes,
                        Zeiger);
                  else
                     exit;
                  end if;
                  Zf2 := Zf2.Weitere;
               end loop;
               Zf := Zf.Weitere;
            end loop;
            Af := Af.Andere;
         end loop;
      end loop;
      return Zeiger;
   end Neben;

   -- Die Funktion First berechnet die mglichen Anfangsterminale 
   --  nach folgender Formel: 
   --  b in first(A) => A Transitive-Huelle(Anfang) b
   --  Hierzu stuetzt sie sich auf mehrere Funktionen 
   --  des Packages Matrix sowie auf die Funktion Anfang ab.
   --  Die erste Schleife durchlaeuft die Nichtterminalen.
   --  In der zweiten Schleife wird die komplette Matrix durchlaufen
   --  und geprueft, ob das Nichtterminale Element in der Matrix 
   --  enthalten ist.
   --  Ist dies der Fall wird das Element der Ergebnisliste
   --  hinzugefuegt, bzw. eine neue Liste erstellt.
   --  Am Ende wird die Ergebnisliste zurueckgegeben.


   function First return Tupelpoint is 
      Matrix : Z_Matrix   := Erzeugeadimatrix (Anfang);  
      H      : Tupelpoint;  
   begin
      Matrix := Transhuelle(Matrix);
      for N in Nichtterminal'range loop
         for I in Matrix'range loop
            if Istterminal(I) and then Matrix(N,I) then
               if H = null then
                  H := new Tupel'(N,I,null);
               else
                  H := new Tupel'(N,I,H);
               end if;
            end if;
         end loop;

      end loop;

      return H;
   end First;


   -- Die Funktion berechnet die mglichen Endterminale
   --  nach der Formel: (RTH = Reflexiv-Transitive-Huelle)
   --  Vereinigung (( S RTH(Ende) A),
   --  (A [(RTH(Ende^-1)) Neben (RTH(Anfang)] b))
   --  Die Auswertung der neu entstandenen Matrix erfolgt
   --  analog zu der Vorgehensweise in First.


   function Follow return Tupelpoint is 
      Matrix1,  
      Matrix2 : Z_Matrix      := Erzeugeadimatrix (Ende);  
      H       : Tupelpoint    := null;  
      S       : Nichtterminal := Startsymbol;  
      Endsym  : Terminal      := Terminal'Last; 
   begin
      Put(Terminal'Image(Endsym));
      Matrix1 := Transition(Transition(Reflextranshuelle
            (Transponiere(Matrix1)),Erzeugeadimatrix(Neben)),
         (Reflextranshuelle(Erzeugeadimatrix(Anfang))));
      Matrix2 := Reflextranshuelle(Matrix2);
      for N in Nichtterminal'range loop
         for I in Matrix1'range loop
            if Istterminal(I) and then Matrix1(N,I) then
               if H = null then
                  H := new Tupel'(N,I,null);
               else
                  H := new Tupel'(N,I,H);
               end if;
            end if;
         end loop;
         if Matrix2(S,N) then
            H := new Tupel'(N,Endsym,H);
         end if;
      end loop;
      return H;
   end Follow;

end Relationenpaket;
      
      
   